local Stack1Base, Stack2Base, State2 = st8.new(), st8.new(), st8.new()

local stack2exited
local state2exited

--use Stack 1 to test Stack pause and resume
Stack1Base.paused = nil
Stack1Base.resumed = nil
function Stack1Base:pause()
  Stack1Base.paused = true
end
function Stack1Base:resume()
  Stack1Base.resumed = true
end

function Stack1Base:draw()
  love.graphics.print("STACK 1 STATE 1", 10, 10)
  if Stack1Base.paused then
    love.graphics.print("I was paused", 10, 50)
  end
  if Stack1Base.resumed then
    love.graphics.print("Now I am resumed", 10, 100)
  end
  
  if stack2exited then
    love.graphics.print("Stack 2 has been exited!", 200, 10)
  end
end

function Stack1Base:keypressed(key)
  if self then return self end
  if key == "return" then
    st8.pause(Stack2Base)
  end
end


--use Stack 2 Base to test Stack Enter and Exit (including exit persistence) and State Pause and Resume (push/pop)
Stack2Base.entered = nil
Stack2Base.exited = nil
Stack2Base.paused = nil
Stack2Base.resumed = nil
Stack2Base.gainedFocus = nil
Stack2Base.lostFocus = nil
Stack2Base.arg = nil
function Stack2Base:enter()
  Stack2Base.entered = true
end
function Stack2Base:exit()
  stack2exited = true
  Stack2Base.exited = true
end
function Stack2Base:pause()
  Stack2Base.paused = true
end
function Stack2Base:resume()
  Stack2Base.resumed = true
end
function Stack2Base:gainfocus(arg)
  Stack2Base.gainedFocus = true
  if arg then Stack2Base.arg = arg end
end
function Stack2Base:losefocus()
  Stack2Base.gainedFocus = Stack2Base.lostFocus -- essentially remove the focus gain from enter() the first time we lose focus (by pushing)
  Stack2Base.lostFocus = true
  
end

function Stack2Base:draw()
  love.graphics.print("STACK 2 STATE 1", 10, 10)
  if Stack2Base.entered then
    love.graphics.print("I have been entered", 10, 50)
  end
  if Stack2Base.exited then
    love.graphics.print("I was previously exited!", 10, 100)
  end
  if Stack2Base.paused then --this fails
    love.graphics.print("I was paused!", 10, 150)
  end
  if Stack2Base.resumed then -- this fails
    love.graphics.print("I've been resumed!", 10, 200)
  end
  if Stack2Base.lostFocus then
    love.graphics.print("I lost Focus once!", 10, 250)
  end
  if Stack2Base.lostFocus and Stack2Base.gainedFocus then -- don't display the first time we gainfocus (from enter())
    love.graphics.print("Then I got it back!", 10, 300)
  end
  if state2exited then
    love.graphics.print("State 2 has been exited!", 200, 10)
  end
  if Stack2Base.arg then
    love.graphics.print("I received an arg: " .. Stack2Base.arg, 10, 350)
  end
end

function Stack2Base:keypressed(key)
  if self then return self end
  
  if key == "return" then
    st8.push(State2)
  end
  if key == "escape" then
    st8.resume()
  end
end


-- use State2 to test State Enter, Exit (persistence) (push/pop)
State2.entered = nil
State2.exited = nil
function State2:enter()
  State2.entered = true
end
function State2:exit()
  state2exited = true
  State2.exited = true
end

function State2:draw()
  love.graphics.print("STACK 2 STATE 2", 200, 50)
  if State2.entered then
    love.graphics.print("I have been entered", 200, 100)
  end
  if State2.exited then
    love.graphics.print("I was previously exited!", 200, 150)
  end
end

function State2:keypressed(key)
  if key == "escape" then
    st8.pop(1, "hello")
  end
  return true
end


return Stack1Base

